(function() {
  'use strict';
  var isPassed = false;
  var continueBtn;
  var TOTAL_ITEMS = 8,
    TOTAL_NUMBER = 255;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_10_multiple_choice = {};
  window.mheAdditionalActivities.chapter_10_multiple_choice.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_10_multiple_choice.show = function( section ) {
    Show( section );
  };

  var Init = function( section ) {
    var $container = $('.dnd_container');
    var draggableOffsets = {};
    var submitBtn = $(".submitBtn");
    var answers = new Array( 8 );
    var sectionNode = section.jq[0];
    var feedbackContainer = $(".feedbackContainer");

    submitBtn.click( "click", checkAnswer );
    submitBtn.hide();
    $container.disableSelection();

    function snapDraggable( $draggable, $droppable, saveSnap ) {
      var droppableOffset = $droppable.offset(),
        draggableId = $draggable.attr('id');

      var top = droppableOffset.top - draggableOffsets[draggableId].top,
        left = droppableOffset.left - draggableOffsets[draggableId].left;

      $draggable.animate({ top: top, left: left }, 200);

      if ( saveSnap ) {
        var $prevPosition = $('#' + $draggable.data('droppable'));
        var draggableInPrevPosition = $prevPosition.data('draggable');
        if ( draggableInPrevPosition === draggableId ) {
          $prevPosition.data('draggable', '');
        }

        $draggable.data('droppable', $droppable.attr('id'));
        $droppable.data('draggable', $draggable.attr('id'));

        $draggable.attr('data-droppable', $droppable.attr('id'));
      }
    }

    function checkAnswer(){
      var length,
        draggableIndex,
        droppableIndex,
        totalNumber,
        dragId,
        dropId,
        i;

      var dragItems = sectionNode.querySelectorAll(".draggable-item");

      for( i = 0; i < answers.length; i++ ){
        dragId = dragItems[i].id;
        dropId = dragItems[i].getAttribute("data-droppable");

        length = dragId.length;
        draggableIndex = dragId.substring( length - 1, length );
        draggableIndex = parseInt( draggableIndex, 10 );

        length = dropId.length;
        droppableIndex = dropId.substring( length - 1, length );
        droppableIndex = parseInt( droppableIndex, 10 );

        if( droppableIndex === draggableIndex ){
          answers[ droppableIndex - 1 ] = 1;
        } else {
          answers[ droppableIndex - 1 ] = 0;
        }
      }

      totalNumber = parseInt( answers.join(""), 2 );

      //submitBtn.css("opacity","1");
      //submitBtn.css('cursor','pointer');

      if( totalNumber === TOTAL_NUMBER ){
        isPassed = true;
        section.passed = "passed";

        feedbackContainer.hide();
        submitBtn.hide();
        $( continueBtn ).show();

        $container.animate({
          height: 300
        });
      } else {

        var timeMoving = 1500;

        var $droppables =  $('.background-line-block');
        var $draggables  = $('.draggable-item');

        $droppables.data('draggable',null);
        $($droppables[0]).data('draggable',null);
        $($droppables[1]).data('draggable',null);
        $($droppables[2]).data('draggable',null);
        $($droppables[3]).data('draggable',null);
        $($droppables[4]).data('draggable',null);
        $($droppables[5]).data('draggable',null);
//
        $draggables.data('droppable',null);
        $($draggables[0]).data('droppable',null);
        $($draggables[1]).data('droppable',null);
        $($draggables[2]).data('droppable',null);
        $($draggables[3]).data('droppable',null);
        $($draggables[4]).data('droppable',null);
        $($draggables[5]).data('droppable',null);

        $('.draggable-item').animate({top:'0px'},500);
        //submitBtn.attr('disabled',true);
        //submitBtn.css('opacity',0.5);
        //submitBtn.css('cursor','default');

        //$('#digfir_section_25').animate({height:620},500);

        feedbackContainer.text("Incorrect. Please try again.");
      }
    }

    $('.background-line-block').droppable({
      hoverClass: 'placeholder-item',
      drop: function( event, ui ) {
        var $draggable = ui.draggable;
        var $droppable = $(this);
        var occupied = $droppable.data('draggable');
        var draggableFrom;

        draggableFrom = $draggable.data('droppable');
        if ( occupied && draggableFrom) {
          var $currentDraggable = $('#' + occupied);
          var $moveTo = $('#' + draggableFrom);

          snapDraggable($currentDraggable, $moveTo, true);
          snapDraggable( $draggable, $droppable, true );
        }
        else if ( !occupied ) {
          snapDraggable( $draggable, $droppable, true );
        }

        var draggableData = $('.draggable-item:data(droppable)');
        if ( draggableData.length >= TOTAL_ITEMS && !isPassed ) {
          isPassed = true;
          submitBtn.show();
        }
      }
    });

    $('.draggable-item').draggable({
      start: function ( event, ui ) {
        var $this = $(this);
        var id = $(this).attr('id');

        if (draggableOffsets[id]) { return; }
        draggableOffsets[id] = $this.offset();
      },
      stop: function ( event, ui ) {
        var $this = $(this);
        var droppable_node;

        if ($this.data('droppable')) {
          droppable_node = $('#' + $this.data('droppable') );

          snapDraggable( $this, droppable_node );
        } else {
          $this.animate({ top: 0, left: 0 }, 200);
        }

      },
      stack: '.draggable-item',
      tolerance: 'pointer',
      revert: 200
    }).disableSelection();

  }; //end init

  var Show = function( section ) {
    continueBtn = document.getElementById('step_next_button' );

    if( isPassed ){
      //continueBtn.style.display = 'block';
      section.passed = "passed";
    } else {
      continueBtn.style.display = 'none';
      //section.passed = "no_passed";
    }
  };

})();