(function() {
  'use strict';
  var isPassed = false;
  var continueBtn;
  var TOTAL_ITEMS = 11,
    TOTAL_NUMBER = 2047,
    tries = 0;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_10_multiple_choice_2 = {};
  window.mheAdditionalActivities.chapter_10_multiple_choice_2.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_10_multiple_choice_2.show = function( section ) {
    Show( section );
  };

  var answers = [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    values = [
      101.918,
      2,
      58,
      "0.00",
      3.133,
      0.001,
      8.267,
      "0.00",
      "11.400",
      "0.00",
      0.778
    ];

  var Init = function( section ) {
    shuffleValues(section);

    var $container = $('#digfir_section_33 .dnd_container' );
    var draggableOffsets = {};

    var submitBtn = $(".submitBtn1");
    var feedbackContainer = $(".feedbackContainer1");

    submitBtn.click( "click", checkAnsver);
    submitBtn.hide();

    $container.disableSelection();

    function snapDraggable( $draggable, $droppable, saveSnap ) {
      var droppableOffset = $droppable.offset(),
          draggableId = $draggable.attr('id');

      var top = droppableOffset.top - draggableOffsets[draggableId].top,
          left = droppableOffset.left - draggableOffsets[draggableId].left;

      $draggable.animate({ top: top, left: left }, 200);

      if ( saveSnap ) {
        var $prevPosition = $('#digfir_section_33 #' + $draggable.data('droppable'));
        var draggableInPrevPosition = $prevPosition.data('draggable');
        if ( draggableInPrevPosition === draggableId ) {
          $prevPosition.data('draggable', '');
        }

        $draggable.data('droppable', $droppable.attr('id'));
        $droppable.data('draggable', $draggable.attr('id'));
      }
    }

    function checkAnsver(){
      var draggableItem = $('#digfir_section_33 .draggable-item:data(droppable)');
      if ( draggableItem.length >= TOTAL_ITEMS && !isPassed ) {
        isPassed = true;
      }

      //var totalNumber = answers.join("");
      var totalNumber = parseInt( answers.join(""), 2 );
      //totalNumber = parseInt( totalNumber, 2 );

      if( totalNumber === TOTAL_NUMBER ){

        isPassed = true;
        section.passed = "passed";

        submitBtn.hide();
        $( continueBtn ).show();
        feedbackContainer.text("This would be the correct order");
      } else {
        feedbackContainer.text("This order is incorrect. Please try again.");
      }

      tries += 1;

      if( (isPassed && tries === 3 ) || ( !isPassed && tries === 3 ) ){
        continueBtn.style.display = 'block';
        feedbackContainer.hide();
        submitBtn.hide();

        isPassed = true;
        return;
      }
    }
    $('#digfir_section_33 .background-line-block').droppable({
      hoverClass: 'placeholder-item',
      drop: function ( event, ui ) {

        var $draggable = ui.draggable;
        var $droppable = $(this);
        var occupied = $droppable.data('draggable');
        var draggableFrom;

        var draggableId = $draggable.attr("id"),
            droppableId = $droppable.attr("id");

        if ( occupied && (draggableFrom = $draggable.data('droppable'))) {
          // If we drop element to full item - switch this
          var $currentDraggable = $('#digfir_section_33 #' + occupied);
          var $moveTo = $('#digfir_section_33 #' + draggableFrom);

          snapDraggable( $currentDraggable, $moveTo, true);
          snapDraggable( $draggable, $droppable, true );

          checkConsist( occupied, draggableFrom );
        } else if ( !occupied ) {
          snapDraggable( $draggable, $droppable, true );
        }
        submitBtn.show();
        checkConsist( draggableId, droppableId );
      }
    });

    $('#digfir_section_33 .draggable-item').draggable({
      start: function ( event, ui ) {
        var $this = $(this);
        var id = $(this).attr('id');

        if (draggableOffsets[id]) { return; }
        draggableOffsets[id] = $this.offset();
      },
      stop: function ( event, ui ) {
        var $this = $(this);
        var droppable_node;

        if ($this.data('droppable')) {
          droppable_node = $('#digfir_section_33 #' + $this.data('droppable') );

          snapDraggable( $this, droppable_node );
        } else {
          $this.animate({ top: 0, left: 0 }, 200);
        }

      },
      stack: '.draggable-item',
      tolerance: 'pointer',
      revert: 200
    }).disableSelection();

  }; //end init

  function shuffleValues( section ){
    var items,
        indicies = [1,2,3,4,5,6,7,8,9,10,11],
        random_num,
        index,
        length,
        i;

    items = section.jq[0].querySelectorAll(".draggable-item");

    for( i = 0; i < items.length; i += 1 ){
      length = indicies.length - 1;
      random_num = getRandom(0, length );

      index = indicies[random_num];
      items[i].id = "draggable_item_" + index;
      items[i].innerHTML = values[index - 1];

      indicies.splice(random_num, 1);
    }
  }

  function checkConsist( dragId, dropId ){
    var splittedId, draggableIndex, droppableIndex;

    splittedId = dragId.split("_");
    draggableIndex = splittedId.pop();
    draggableIndex = parseInt( draggableIndex, 10 );

    splittedId = dropId.split("_");
    droppableIndex = splittedId.pop();
    droppableIndex = parseInt( droppableIndex, 10 );

    if( droppableIndex === draggableIndex ||
        values[droppableIndex - 1] == values[draggableIndex - 1] ){
      answers[ droppableIndex - 1 ] = 1;
    } else {
      answers[ droppableIndex - 1 ] = 0;
    }
  }

  function getRandom( from, to ){
    return Math.round( Math.random() * to ) + from;
  }

  var Show = function( section ) {
    continueBtn = document.getElementById('step_next_button');
    if( isPassed ){
      //continueBtn.style.display = 'block';
      section.passed = "passed";
    } else {
      //continueBtn.style.display = 'none';
      section.passed = "no_passed";
    }
  };

})();