(function() {
  'use strict';
  var isPassed = false,
    TOTAL_MESSAGES = 5,
    STEPS = 5;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_10_table_activity_1 = {};
  window.mheAdditionalActivities.chapter_10_table_activity_1.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_10_table_activity_1.show = function( section ) {
    Show( section );
  };

  var currentStep = 0,
    previousMessage,
    svgLines,
    svg_node,
    section_global,
    continueBtn,
    datas = [[],[],[],[],[]],
    messages_node = [];

  var Init = function( section ) {
    section_global = section;

     var section_node = section.jq[0],
       message_id = "#message_",
       cells,
       i;

    svg_node = section_node.querySelector("svg");
    svg_node.addEventListener("click", drawArrow );
    svgLines = svg_node.querySelectorAll(".main-arrow");

    hideArrows();

    // Save messages node
    var message;
    for( i = 0; i < TOTAL_MESSAGES; i += 1 ){
      message = section_node.querySelector( message_id + ( i + 1 ) );
      message.style.display = "none";
      messages_node.push( message );
    }

    cells = section_node.querySelectorAll( ".activity-cell" );

    var data_cell,
      data,
      index,
      j;

    // matching the "td" and messages in arrays ( messages_node and datas )
    // for example: messages[0] has message from table data(-s) which contain in datas[0].
    for( i = 0; i < cells.length; i += 1 ){
      data_cell = cells[i].getAttribute("data-activity");

      data = data_cell.split(",");

      for( j = 0; j < data.length; j += 1 ){
        data[j] = parseInt( data[j], 10 );
        index = data[j] - 1;

        datas[index].push( cells[i] );
      }
    }

  }; //end init

  function drawArrow(){
    hideArrows();

    var currentData,
      currentMessage,
      widthElem,
      heightElem,
      endPos = [],
      startPos = [],
      ellipse_node,
      ellipseCoords = [
        0, 0, 0, [683,104,57,15], 0
      ],
      offsets = [0, 0, 0, 10, 0];

    if( currentStep === STEPS ){
      currentStep = 0;

      if( !isPassed ){
        //continueBtn.style.display = 'block';
        section_global.passed = "passed";
      }
    }

    currentData = datas[currentStep];
    currentMessage = messages_node[currentStep];

    currentMessage.style.display = "block";
    previousMessage && ( previousMessage.style.display = "none" );
    previousMessage = currentMessage;

    var messageOffset = getOffsetRect( currentMessage ),
      svgOffset = getOffsetRect( svg_node );

    widthElem = currentMessage.offsetWidth / 2;

    startPos.push( messageOffset.top - svgOffset.top );
    startPos.push( messageOffset.left - svgOffset.left + widthElem );

    var dataOffset;
    for( var i = 0; i < currentData.length; i += 1 ){
      dataOffset = getOffsetRect( currentData[i] );

      widthElem = currentData[i].offsetWidth / 2;
      heightElem = currentData[i].offsetHeight;

      endPos[i] = [];
      endPos[i].push( dataOffset.top - svgOffset.top + heightElem + offsets[currentStep] );
      endPos[i].push( dataOffset.left - svgOffset.left + widthElem - 10 );
    }

    for( var j = 0; j < endPos.length; j += 1 ){
      svgLines[j].setAttribute( "x1", startPos[1] );
      svgLines[j].setAttribute( "y1", startPos[0] );

      startPos[1] += 20;

      svgLines[j].setAttribute( "x2", endPos[j][1] );
      svgLines[j].setAttribute( "y2", endPos[j][0] );

      svgLines[j].style.display = "block";
    }

    if( !ellipse_node ){
      ellipse_node = svg_node.querySelector("ellipse");
    }

    ellipse_node.style.display = "none";

    if( ellipseCoords[currentStep] ){
      ellipse_node.style.display = "block";

      ellipse_node.setAttribute("cx", ellipseCoords[currentStep][0] );
      ellipse_node.setAttribute("cy", ellipseCoords[currentStep][1] );
      ellipse_node.setAttribute("rx", ellipseCoords[currentStep][2] );
      ellipse_node.setAttribute("ry", ellipseCoords[currentStep][3] );
    }

    currentStep += 1;
  }

  function hideArrows(){
    if( svgLines ){
      for( var i = 0; i < svgLines.length; i += 1 ){
        svgLines[i].style.display = "none";
      }
    }
  }

  function getOffsetRect( elem ){
    var box = elem.getBoundingClientRect();

    var body = document.body,
      docElem = document.documentElement;

    var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
      scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;

    var clientTop = docElem.clientTop || body.clientTop || 0,
      clientLeft = docElem.clientLeft || body.clientLeft || 0;

    var top = box.top +  scrollTop - clientTop,
      left = box.left + scrollLeft - clientLeft;

    return {
      top: Math.round( top ),
      left: Math.round( left )
    }
  }

  var Show = function( section ) {
    continueBtn = document.getElementById('step_next_button' );

    /*
    if( isPassed ){
      continueBtn.style.display = 'block';
      section.passed = "passed";
    } else {
      continueBtn.style.display = 'none';
      section.passed = "no_passed";
    }
    */
  };

})();