(function(){
  var isPassed = true;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_11_graph = {};
  window.mheAdditionalActivities.chapter_11_graph.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_11_graph.show = function( section ) {
    Show( section );
  };

  var board,
      graph,
      bars,
      currentSection,
      continueBtn;

  var BOARD_OPTIONS = {
        boundingbox: [ 0, 5, 8, 0],
        showCopyright: false,
        showNavigation: false
      },
      AXIS_OPTIONS_Y = {
        straightFirst: false,
        straightLast: true,
        lastArrow: false,
        strokeWidth: 4,
        ticks: {
          minorTicks: 0,
          minTicksDistance: 16,
          drawLabels: true,
          majorHeight: 750,
          label: {
            offset: [-20, 0],
            highlight: false
          }
        },
        highlight: false
      },
      AXIS_OPTIONS_X = {
        straightFirst: true,
        straightLast: false,
        lastArrow: false,
        strokeWidth: 2,
        ticks: {
          majorHeight: 0,
          tickEndings: [0, -1],
          opacity: 0.2,
          label: {
            visible: false,
            offset: [0, -15],
            highlight: false
          }
        },
        highlight: false
      },
      TICKS_X_OPTIONS = {
        tickEndings: [0, 1],
        strokeColor: '#000',
        strokeWidth: 2,
        minorTicks: 0,
        majorheight: 15,
        labels: ["1 hour", "4 hours"],
        label: {
          offset: [ -25, -10 ]
        },
        drawLabels: true,
        drawZero: true
      },
      AXIS_ARR_Y = [
        [0, 0],
        [0, 1]
      ],
      AXIS_ARR_X = [
        [0, 0],
        [6, 0]
      ];

  var
      BAR_OPTIONS = {
        chartStyle: 'bar',
        width: 1,
        opacity: 1,
        withLines: true,
        colors: ["#2C9DBA", "#D40013", "white", "#2C9DBA", "#D40013" ]
      },
      POINTS_MALE_OPTIONS = {
        name: "Females",
        face: "[]",
        color: "#2C9DBA",
        label: {
          offset: [9, 0]
        }
      },
      POINTS_FEMALE_OPTIONS = {
        name: "Males",
        face: "[]",
        color: "#D40013",
        label: {
          offset: [9, 0]
        }
      };

  var Init = function( section ) {
    currentSection = section;
  };

  var Show = function( section ){
    section.jq[0].style.display = "block";

    if( !graph ){
      createGraph();
    }

    continueBtn = document.getElementById('step_next_button' );

    continueBtn.style.display = 'block';
    section.passed = "passed";

  };

  function createGraph() {
    var x, fixedTicks = [ 1.5, 4.5 ];

    board = G2D.G2DGraph.initBoard( "G2Dbox", BOARD_OPTIONS );

    // Generate x and y axis
    x = board.create('axis', AXIS_ARR_X, AXIS_OPTIONS_X );
    board.create('axis', AXIS_ARR_Y, AXIS_OPTIONS_Y );

    // Create bars
    bars = board.create("chart", [3.53, 4.57, 0, 2.43, 2.47], BAR_OPTIONS );

    //Create ticks
    board.create( "ticks", [x, fixedTicks], TICKS_X_OPTIONS );

    //Create legend
    board.create("point", [7, 2.5], POINTS_MALE_OPTIONS);
    board.create("point", [7, 2.2], POINTS_FEMALE_OPTIONS);

    board.unsuspendUpdate();
    board.update();
  }

})();