(function() {
    'use strict';
    var isPassed = false;
    var continueBtn;
    var TOTAL_ITEMS = 6,
        TRIES = 0, // brb
        MAX_ATTEMPTS = 3, // brb
        SEC_ID = "#digfir_section_24", // brb
        feedbackContainer, // brb
        submitBtn, // brb
        $container, // brb
        TOTAL_NUMBER = 63;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_12_multiple_choice = {};
  window.mheAdditionalActivities.chapter_12_multiple_choice.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_12_multiple_choice.show = function( section ) {
    Show( section );
  };

  var Init = function( section ) {
      // brb
      $container = $('.dnd_container');
      var draggableOffsets = {};
      // brb
      submitBtn = $(".submitBtn");
      var answers = new Array( 6 );
      var sectionNode = section.jq[0];
      // brb
      feedbackContainer = $(".feedbackContainer");

    submitBtn.click( "click", checkAnswer );
    submitBtn.hide();
    $container.disableSelection();

    function snapDraggable( $draggable, $droppable, saveSnap ) {
      var droppableOffset = $droppable.offset(),
          draggableId = $draggable.attr('id');

      var top = droppableOffset.top - draggableOffsets[draggableId].top,
          left = droppableOffset.left - draggableOffsets[draggableId].left;

      $draggable.animate({ top: top, left: left }, 300);

      if ( saveSnap ) {
        var $prevPosition = $('#' + $draggable.data('droppable'));
        var draggableInPrevPosition = $prevPosition.data('draggable');
        if ( draggableInPrevPosition === draggableId ) {
          $prevPosition.data('draggable', '');
        }

        $draggable.data('droppable', $droppable.attr('id'));
        $droppable.data('draggable', $draggable.attr('id'));

        $draggable.attr('data-droppable', $droppable.attr('id'));
      }
    }

    function checkAnswer(){
      var length,
          draggableIndex,
          droppableIndex,
          totalNumber,
          dragId,
          dropId,
          i;

      feedbackContainer.hide();

      var dragItems = sectionNode.querySelectorAll(".draggable-item");

      for( i = 0; i < answers.length; i++ ){
        dragId = dragItems[i].id;
        dropId = dragItems[i].getAttribute("data-droppable");

        length = dragId.length;
        draggableIndex = dragId.substring( length - 1, length );
        draggableIndex = parseInt( draggableIndex, 10 );

        length = dropId.length;
        droppableIndex = dropId.substring( length - 1, length );
        droppableIndex = parseInt( droppableIndex, 10 );

        if( droppableIndex === draggableIndex ){
          answers[ droppableIndex - 1 ] = 1;
        } else {
          answers[ droppableIndex - 1 ] = 0;
        }
      }

      totalNumber = parseInt( answers.join(""), 2 );

        if( totalNumber === TOTAL_NUMBER ){
            isPassed = true;
            section.passed = "passed";
            
            // brb
            feedbackContainer.show();
            feedbackContainer.text("Congratulations. You placed them in the correct order.");
            
            // brb
            //feedbackContainer.hide();
            submitBtn.hide();
            $( continueBtn ).show();
            
            // brb: pass true to submit hidden arga question
            show_answer(true);
            
            $container.animate({
                height: 215
            });
            
        } else {


          // brb: if we have reached the try limit then show answers
          TRIES++;

          if (TRIES >= MAX_ATTEMPTS) {
              feedbackContainer.show();
              feedbackContainer.text("Max attempts reached. Correct answers are shown above.");
              // pass 'true' to submit hidden arga question
              show_answer(true);
              $( continueBtn ).show();
              return;
          }
          
            var timeMoving = 1500;
            
            var $droppables =  $('.background-line-block');
            var $draggables  = $('.draggable-item');
            
            $droppables.data('draggable',null);
            $($droppables[0]).data('draggable',null);
            $($droppables[1]).data('draggable',null);
            $($droppables[2]).data('draggable',null);
            $($droppables[3]).data('draggable',null);
            $($droppables[4]).data('draggable',null);
            $($droppables[5]).data('draggable',null);
            //
            $draggables.data('droppable',null);
            $($draggables[0]).data('droppable',null);
            $($draggables[1]).data('droppable',null);
            $($draggables[2]).data('droppable',null);
            $($draggables[3]).data('droppable',null);
            $($draggables[4]).data('droppable',null);
            $($draggables[5]).data('droppable',null);
            
            $('.draggable-item').animate({top:'0px'},500);
            
            // brb
            feedbackContainer.show();
            feedbackContainer.text("Incorrect. " + TRIES + " of " + MAX_ATTEMPTS + " attempts. Please try again.");
            
            // brb
            isPassed = false;
            submitBtn.hide();
            
        }
    }
    

    $('.background-line-block').droppable({
      hoverClass: 'placeholder-item',
      drop: function( event, ui ) {
        var $draggable = ui.draggable;
        var $droppable = $(this);
        var occupied = $droppable.data('draggable');
        var draggableFrom;

        draggableFrom = $draggable.data('droppable');
        if ( occupied && draggableFrom) {
          var $currentDraggable = $('#' + occupied);
          var $moveTo = $('#' + draggableFrom);

          snapDraggable($currentDraggable, $moveTo, true);
          snapDraggable( $draggable, $droppable, true );
        }
        else if ( !occupied ) {
          snapDraggable( $draggable, $droppable, true );
        }

        var draggableData = $('.draggable-item:data(droppable)');
        if ( draggableData.length >= TOTAL_ITEMS && !isPassed ) {
          isPassed = true;
          submitBtn.show();
        }
      }
    });

    $('.draggable-item').draggable({
      start: function ( event, ui ) {
        var $this = $(this);
        var id = $(this).attr('id');

        if (draggableOffsets[id]) { return; }
        draggableOffsets[id] = $this.offset();
      },
      stop: function ( event, ui ) {
        var $this = $(this);
        var droppable_node;

        if ($this.data('droppable')) {
          droppable_node = $('#' + $this.data('droppable') );

          snapDraggable( $this, droppable_node );
        } else {
          $this.animate({ top: 0, left: 0 }, 200);
        }

      },
      stack: '.draggable-item',
      tolerance: 'pointer',
      revert: 215
    }).disableSelection();


  }; //end init

    // brb: show correct answer and disable dnd
    function show_answer(submit_hidden_arga) {

        // remove submit button
        submitBtn.hide();

        var $sec = $(SEC_ID);
        
        $sec.addClass("dnd_activity_completed");
        
        // place answers in correct spot
        var $draggables  = $(SEC_ID).find('.draggable-item');

        for (var i=1; i<=$draggables.length; i++) {
            //snapDraggable( $(SEC_ID).find("#draggable_item_" + i), $(SEC_ID).find("#droppable_item_" +i), true );
            
            $sec.find("#droppable_item_" +i).html($sec.find("#draggable_item_" + i).html());
            $sec.find("#draggable_item_" + i).remove();
        }
        
        $draggables.each(function() {
            $(this).draggable("disable");
        });

        // submit hidden arga question
        if (submit_hidden_arga) {
            //submit_hidden_arga_question();
        }
        
        $container.animate({
            height: 215
        });
        
    }
    
  var Show = function( section ) {

      continueBtn = document.getElementById('step_next_button' );
      
      if( isPassed ){
          continueBtn.style.display = 'block';
          section.passed = "passed";
      } else {
          continueBtn.style.display = 'none';
          section.passed = "no_passed";
      }

      // brb : If we have already completed this page then show
        // the answer.
        if (player.ARGA_running) {
            
            var all_arga_answered = true;
            var $curr_sec = $(SEC_ID);
            $curr_sec.find("[data-type='question']").each(function() {
                var $this = $(this);
                var q_index = $this.attr("data-question_index");
	        var question = player.activity.questions[q_index];
                
                all_arga_answered = all_arga_answered && (Number(question.queries[0].grade) > -1);
            });
            
            if (all_arga_answered) {
                feedbackContainer.show();
                feedbackContainer.text("This activity has been completed.");
                show_answer();
            }
            
        }
      
  };

})();
