(function() {
    'use strict';
    var isPassed = false,
        TOTAL_MESSAGES = 6,
        STEPS = 6;

    window.mheAdditionalActivities = window.mheAdditionalActivities || {};

    window.mheAdditionalActivities.chapter_12_table_activity = {};
    window.mheAdditionalActivities.chapter_12_table_activity.initialize = function( section ) {
        Init( section );
    };
    window.mheAdditionalActivities.chapter_12_table_activity.show = function( section ) {
        Show( section );
    };

    var currentStep = 0,
        previousMessage,
        svgLines,
        svgNode,
        section_global,
        sectionNode,
        continueBtn,
        datas = [[],[],[],[],[],[]],
        messages_node = [],
        ellipsesNode,
        ellipseCoords = [
             0, 0, 0, [ [690,103,60,20], [690,224,60,20], [620,617,70,20] ], [620,617,70,20], 0
        ];

    var Init = function( section ) {
        //section_global = section;
        sectionNode = section.jq[0];

        var message_id = "#message_",
            cells,
            i;

        svgNode = sectionNode.querySelector("svg");
        svgNode.addEventListener("click", drawArrow );

        // init shapes
        svgLines = svgNode.querySelectorAll(".main-arrow");
        ellipsesNode = svgNode.querySelectorAll("ellipse");

        hideArrows();

        // Save messages node
        var message;
        for( i = 0; i < TOTAL_MESSAGES; i += 1 ){
            message = sectionNode.querySelector( message_id + ( i + 1 ) );
            message.style.display = "none";
            messages_node.push( message );
        }

        cells = sectionNode.querySelectorAll( ".activity-cell" );

        var data_cell,
            data,
            index,
            j;

        // matching the "td" and messages in arrays ( messages_node and datas )
        // for example: messages[0] has message from table data(-s) which contain in datas[0].
        for( i = 0; i < cells.length; i += 1 ){
            data_cell = cells[i].getAttribute("data-activity");

            data = data_cell.split(",");

            for( j = 0; j < data.length; j += 1 ){
                data[j] = parseInt( data[j], 10 );
                index = data[j] - 1;

                datas[index].push( cells[i] );
            }
        }

    }; //end init

    function drawArrow(){
        hideArrows();

        var currentData,
            currentMessage,
            widthElem,
            heightElem,
            endPos = [],
            startPos = [],
            i, j;

        if( currentStep === STEPS ){
            currentStep = 0;

            if( !isPassed ){
                //submit_hidden_arga_question();
                continueBtn.style.display = 'block';
                section_global.passed = "passed";
            }
        }

        currentData = datas[currentStep];
        currentMessage = messages_node[currentStep];

        currentMessage.style.display = "block";
        previousMessage && ( previousMessage.style.display = "none" );
        previousMessage = currentMessage;

        var messageOffset = getOffsetRect( currentMessage ),
            svgOffset = getOffsetRect( svgNode );

        widthElem = currentMessage.offsetWidth / 2;

        startPos.push( messageOffset.top - svgOffset.top );
        startPos.push( messageOffset.left - svgOffset.left + widthElem );

        var dataOffset;
        for( i = 0; i < currentData.length; i += 1 ){
            dataOffset = getOffsetRect( currentData[i] );

            widthElem = currentData[i].offsetWidth / 2;
            heightElem = currentData[i].offsetHeight;

            endPos[i] = [];
            endPos[i].push( dataOffset.top - svgOffset.top + heightElem );
            endPos[i].push( dataOffset.left - svgOffset.left + widthElem );
        }

        for( i = 0; i < endPos.length; i += 1 ){
            svgLines[i].setAttribute( "x1", startPos[1] );
            svgLines[i].setAttribute( "y1", startPos[0] );

            startPos[1] += 20;

            svgLines[i].setAttribute( "x2", endPos[i][1] );
            svgLines[i].setAttribute( "y2", endPos[i][0] );

            svgLines[i].style.display = "block";
        }

        hideEllipses();
        if( ellipseCoords[currentStep] ){
            drawEllipses();
        }
        currentStep++;
    }

    function drawEllipses(){
        var i, j,
          coords = ellipseCoords[currentStep],
          attrs = [ "cx", "cy", "rx", "ry" ];

        if( typeof coords[0] === "object" ){
            for( i = 0; i < coords.length; i++ ){
              ellipsesNode[i].style.display = "block";
              for( j = 0; j < coords[i].length; j++ ){
                    ellipsesNode[i].setAttribute(attrs[j], coords[i][j] );
                }
            }
        } else {
            ellipsesNode[0].style.display = "block";
            for( i = 0; i < coords.length; i++ ){
                // set to first ellipse
                ellipsesNode[0].setAttribute(attrs[i], coords[i] );
            }
        }
    }

    function hideEllipses(){
        var i;
        for( i = 0; i < ellipsesNode.length; i++ ){
            ellipsesNode[i].style.display = "none";
        }
    }

    function hideArrows(){
        if( svgLines ){
            for( var i = 0; i < svgLines.length; i += 1 ){
                svgLines[i].style.display = "none";
            }
        }
    }

    function getOffsetRect( elem ){
        var box = elem.getBoundingClientRect();

        var body = document.body,
            docElem = document.documentElement;

        var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
            scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;

        var clientTop = docElem.clientTop || body.clientTop || 0,
            clientLeft = docElem.clientLeft || body.clientLeft || 0;

        var top = box.top +  scrollTop - clientTop,
            left = box.left + scrollLeft - clientLeft;

        return {
            top: Math.round( top ),
            left: Math.round( left )
        }
    }

    var Show = function( section ) {
        /*
        continueBtn = document.getElementById('step_next_button' );
        if( isPassed ){
            continueBtn.style.display = 'block';
            section.passed = "passed";
        } else {
            continueBtn.style.display = 'none';
            section.passed = "no_passed";
        }
        */
    };

})();
