(function() {
    'use strict';
    var isPassed = false;

    window.mheAdditionalActivities = window.mheAdditionalActivities || {};

    window.mheAdditionalActivities.chapter_12_table_activity_2 = {};
    window.mheAdditionalActivities.chapter_12_table_activity_2.initialize = function( section ) {
        Init( section );
    };
    window.mheAdditionalActivities.chapter_12_table_activity_2.show = function( section ) {
        Show( section );
    };

    var currentStep = 0,
        previousMessage,
        section_node,
        messages,
        svgLines,
        svg_node,
        ellipses,
        section_global,
        continueBtn,
        ellipse_node,
        ellipseCoords = [
            0, 0, 0, 0, 0, 0
        ],
        datas = [],
        messages_node = [];

    var Init = function( section ) {
        section_global = section;
        section_node = section.jq[0];

        var cells, i;

        svg_node = section_node.querySelector("svg");
        svg_node.addEventListener("click", drawArrow );

        svgLines = svg_node.querySelectorAll(".main-arrow");

        hideArrows();

        // Save messages node
        messages = section_node.querySelectorAll(".table-message");

        for( i = 0; i < messages.length; i += 1 ){
            messages[i].style.display = "none";
            messages_node.push( messages[i] );
        }

        cells = section_node.querySelectorAll( ".activity-cell" );
        ellipses = section_node.querySelectorAll(".main-ellipse");

        var data_cell,
            data,
            index,
            j;

        // matching the "td" and messages in arrays ( messages_node and datas )
        // for example: messages[0] has message from table data(-s) which contain in datas[0].
        var support;
        for( i = 0; i < cells.length; i += 1 ){
            data_cell = cells[i].getAttribute("data-activity");

            data = data_cell.split(",");
            support = [];
            for( j = 0; j < data.length; j += 1 ){
                data[j] = parseInt( data[j], 10 );
                index = data[j] - 1;

                support.push( cells[i] );

                if( datas[index] ){
                    datas[index].push( cells[i] )
                } else {
                    datas[index] = [];
                    datas[index].push( cells[i] );
                }
            }
        }

    }; //end init

    function drawArrow(){
        hideArrows();

        var currentData,
            currentMessage,
            widthElem,
            heightElem,
            endPos = [],
            startPos = [];

        if( currentStep === messages.length ){
            currentStep = 0;


            if( !isPassed ){
                continueBtn.style.display = 'block';
                section_global.passed = "passed";
            }
        }

        currentData = datas[currentStep];
        currentMessage = messages_node[currentStep];

        currentMessage.style.display = "block";
        previousMessage && ( previousMessage.style.display = "none" );
        previousMessage = currentMessage;

        var messageOffset = getOffsetRect( currentMessage ),
            svgOffset = getOffsetRect( svg_node );

        widthElem = currentMessage.offsetWidth / 2;

        startPos.push( messageOffset.top - svgOffset.top );
        startPos.push( messageOffset.left - svgOffset.left + widthElem );

        var dataOffset;
        for( var i = 0; i < currentData.length; i += 1 ){
            dataOffset = getOffsetRect( currentData[i] );

            widthElem = currentData[i].offsetWidth / 2;
            heightElem = currentData[i].offsetHeight;

            endPos[i] = [];
            endPos[i].push( dataOffset.top - svgOffset.top + heightElem );
            endPos[i].push( dataOffset.left - svgOffset.left + widthElem );
        }

        for( var j = 0; j < endPos.length; j += 1 ){
            svgLines[j].setAttribute( "x1", startPos[1] );
            svgLines[j].setAttribute( "y1", startPos[0] );

            startPos[1] += 20;

            svgLines[j].setAttribute( "x2", endPos[j][1] );
            svgLines[j].setAttribute( "y2", endPos[j][0] );

            svgLines[j].style.display = "block";
        }

        var l;
        if( ellipseCoords[currentStep] ){
            var length = ellipseCoords[currentStep].length,
                currentEllipseCoords = ellipseCoords[currentStep];

            for( l = 0; l < length; l += 1 ){
                ellipses[l].style.display = "block";

                ellipses[l].setAttribute("cx", currentEllipseCoords[l][0] );
                ellipses[l].setAttribute("cy", currentEllipseCoords[l][1] );
                ellipses[l].setAttribute("rx", currentEllipseCoords[l][2] );
                ellipses[l].setAttribute("ry", currentEllipseCoords[l][3] );
            }
        } else {
            for( l = 0; l < ellipses.length; l += 1 ){
                ellipses[l].style.display = "none";
            }
        }

        currentStep += 1;
    }

    function hideArrows(){
        if( svgLines ){
            for( var i = 0; i < svgLines.length; i += 1 ){
                svgLines[i].style.display = "none";
            }
        }
    }

    function getOffsetRect( elem ){
        var box = elem.getBoundingClientRect();

        var body = document.body,
            docElem = document.documentElement;

        var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
            scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;

        var clientTop = docElem.clientTop || body.clientTop || 0,
            clientLeft = docElem.clientLeft || body.clientLeft || 0;

        var top = box.top +  scrollTop - clientTop,
            left = box.left + scrollLeft - clientLeft;

        return {
            top: Math.round( top ),
            left: Math.round( left )
        }
    }

    var Show = function( section ) {
        continueBtn = document.getElementById('step_next_button' );

        if( isPassed ){
            continueBtn.style.display = 'block';
            section.passed = "passed";
        } else {
            continueBtn.style.display = 'none';
            section.passed = "no_passed";
        }
    };

})();