(function(){
  var isPassed = false;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};

  window.mheAdditionalActivities.chapter_12_table_graph = {};
  window.mheAdditionalActivities.chapter_12_table_graph.initialize = function( section ) {
    Init( section );
  };
  window.mheAdditionalActivities.chapter_12_table_graph.show = function( section ) {
    Show( section );
  };

  var board,
      graph,
      bars,
      currentSection,
      continueBtn;

  var currentStep = 0,
      previousMessage,
      section_node,
      messages,
      svgLines,
      svg_node,
      ellipses,
      section_global,
      continueBtn,
      ellipse_node,
      ellipseCoords = [
        0, 0, 0, 0, 0, 0
      ],
      datas = [],
      messages_node = [];

  var BOARD_OPTIONS = {
        boundingbox: [ 0, 5, 11, 0],
        showCopyright: false,
        showNavigation: false
      },
      AXIS_OPTIONS_Y = {
        straightFirst: false,
        straightLast: true,
        lastArrow: false,
        strokeWidth: 4,
        ticks: {
          minorTicks: 0,
          minTicksDistance: 16,
          drawLabels: true,
          majorHeight: 1000,
          label: {
            offset: [-20, 0],
            highlight: false
          }
        },
        highlight: false
      },
      AXIS_OPTIONS_X = {
        straightFirst: true,
        straightLast: false,
        lastArrow: false,
        strokeWidth: 2,
        ticks: {
          majorHeight: 0,
          tickEndings: [0, -1],
          opacity: 0.2,
          label: {
            visible: false,
            offset: [0, -15],
            highlight: false
          }
        },
        highlight: false
      },
      TICKS_X_OPTIONS = {
        tickEndings: [0, 1],
        strokeColor: '#000',
        strokeWidth: 2,
        minorTicks: 0,
        majorheight: 15,
        labels: ["6 hour", "8 hour", "10 hour"],
        label: {
          offset: [ -25, -10 ]
        },
        drawLabels: true,
        drawZero: true
      },
      AXIS_ARR_Y = [
        [0, 0],
        [0, 1]
      ],
      AXIS_ARR_X = [
        [0, 0],
        [14, 0]
      ];

  var
      BAR_OPTIONS = {
        chartStyle: 'bar',
        width: 1,
        withLines: true,
        opacity: 1,
        colors: ["#2C9DBA", "#D40013", "white", "#2C9DBA", "#D40013","white", "#2C9DBA", "#D40013" ]
      },
      POINTS_MALE_OPTIONS = {
        name: "Females",
        face: "[]",
        color: "#D40013",
        label: {
          offset: [9, 0]
        },
        frozen: true,
        highlight: false,
      },
      POINTS_FEMALE_OPTIONS = {
        name: "Males",
        face: "[]",
        color: "#2C9DBA",
        label: {
          offset: [9, 0]
        },
        frozen: true,
        highlight: false
      };

  var Init = function( section ) {
    currentSection = section;

    section_node = section.jq[0];

    var cells, i;

    svg_node = section_node.querySelector("svg");
    svg_node.addEventListener("click", drawArrow );

    svgLines = svg_node.querySelectorAll(".main-arrow");

    hideArrows();

    // Save messages node
    messages = section_node.querySelectorAll(".table-message");

    for( i = 0; i < messages.length; i += 1 ){
      messages[i].style.display = "none";
      messages_node.push( messages[i] );
    }

    cells = section_node.querySelectorAll( ".activity-cell" );
    ellipses = section_node.querySelectorAll(".main-ellipse");

    var data_cell,
        data,
        index,
        j;

    // matching the "td" and messages in arrays ( messages_node and datas )
    // for example: messages[0] has message from table data(-s) which contain in datas[0].
    var support;
    for( i = 0; i < cells.length; i += 1 ){
      data_cell = cells[i].getAttribute("data-activity");

      data = data_cell.split(",");
      support = [];
      for( j = 0; j < data.length; j += 1 ){
        data[j] = parseInt( data[j], 10 );
        index = data[j] - 1;

        support.push( cells[i] );

        if( datas[index] ){
          datas[index].push( cells[i] )
        } else {
          datas[index] = [];
          datas[index].push( cells[i] );
        }
      }
    }
  };

  function drawArrow(){
    hideArrows();

    var currentData,
        currentMessage,
        widthElem,
        heightElem,
        endPos = [],
        startPos = [];

    if( currentStep === messages.length ){
      currentStep = 0;


        if( !isPassed ){
            //submit_hidden_arga_question();
        continueBtn.style.display = 'block';
        section_global.passed = "passed";
      }
    }

    currentData = datas[currentStep];
    currentMessage = messages_node[currentStep];

    currentMessage.style.display = "block";
    previousMessage && ( previousMessage.style.display = "none" );
    previousMessage = currentMessage;

    var messageOffset = getOffsetRect( currentMessage ),
        svgOffset = getOffsetRect( svg_node );

    widthElem = currentMessage.offsetWidth / 2;

    startPos.push( messageOffset.top - svgOffset.top );
    startPos.push( messageOffset.left - svgOffset.left + widthElem );

    var dataOffset;
    for( var i = 0; i < currentData.length; i += 1 ){
      dataOffset = getOffsetRect( currentData[i] );

      widthElem = currentData[i].offsetWidth / 2;
      heightElem = currentData[i].offsetHeight;

      endPos[i] = [];
      endPos[i].push( dataOffset.top - svgOffset.top + heightElem );
      endPos[i].push( dataOffset.left - svgOffset.left + widthElem );
    }

    for( var j = 0; j < endPos.length; j += 1 ){
      svgLines[j].setAttribute( "x1", startPos[1] );
      svgLines[j].setAttribute( "y1", startPos[0] );

      startPos[1] += 20;

      svgLines[j].setAttribute( "x2", endPos[j][1] );
      svgLines[j].setAttribute( "y2", endPos[j][0] );

      svgLines[j].style.display = "block";
    }

    var l;
    if( ellipseCoords[currentStep] ){
      var length = ellipseCoords[currentStep].length,
          currentEllipseCoords = ellipseCoords[currentStep];

      for( l = 0; l < length; l += 1 ){
        ellipses[l].style.display = "block";

        ellipses[l].setAttribute("cx", currentEllipseCoords[l][0] );
        ellipses[l].setAttribute("cy", currentEllipseCoords[l][1] );
        ellipses[l].setAttribute("rx", currentEllipseCoords[l][2] );
        ellipses[l].setAttribute("ry", currentEllipseCoords[l][3] );
      }
    } else {
      for( l = 0; l < ellipses.length; l += 1 ){
        ellipses[l].style.display = "none";
      }
    }

    currentStep += 1;
  }

  function hideArrows(){
    if( svgLines ){
      for( var i = 0; i < svgLines.length; i += 1 ){
        svgLines[i].style.display = "none";
      }
    }
  }

  function getOffsetRect( elem ){
    var box = elem.getBoundingClientRect();

    var body = document.body,
        docElem = document.documentElement;

    var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
        scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;

    var clientTop = docElem.clientTop || body.clientTop || 0,
        clientLeft = docElem.clientLeft || body.clientLeft || 0;

    var top = box.top +  scrollTop - clientTop,
        left = box.left + scrollLeft - clientLeft;

    return {
      top: Math.round( top ),
      left: Math.round( left )
    }
  }

  var Show = function( section ){
    section.jq[0].style.display = "block";

    if( !graph ){
      createGraph();
    }

    /*
    continueBtn = document.getElementById('step_next_button' );

    if( isPassed ){
      continueBtn.style.display = 'block';
      section.passed = "passed";
    } else {
      continueBtn.style.display = 'none';
      section.passed = "no_passed";
    }
    */

  };

  function createGraph() {
    var x, fixedTicks = [ 1.5, 4.7, 7.6 ];

    board = G2D.G2DGraph.initBoard( "G2Dbox", BOARD_OPTIONS );

    // Generate x and y axis
    x = board.create('axis', AXIS_ARR_X, AXIS_OPTIONS_X );
    board.create('axis', AXIS_ARR_Y, AXIS_OPTIONS_Y );

    // Create bars
    bars = board.create("chart", [2.5, 3.5, 0, 3.47, 4.65, 0, 2.55, 3.40], BAR_OPTIONS );

    //Create ticks
    board.create( "ticks", [x, fixedTicks], TICKS_X_OPTIONS );

    //Create legend
    board.create("point", [9, 2.5], POINTS_MALE_OPTIONS);
    board.create("point", [9, 2.2], POINTS_FEMALE_OPTIONS);

    board.unsuspendUpdate();
    board.update();
  };
})();
