(function() {
    'use strict';
    var isPassed = false,
      TOTAL_MESSAGES = 10,
      STEPS = 10;
  
    window.mheAdditionalActivities = window.mheAdditionalActivities || {};
  
    window.mheAdditionalActivities.chapter_6_table_activity_1 = {};
    window.mheAdditionalActivities.chapter_6_table_activity_1.initialize = function( section ) {
      Init( section );
    };
    window.mheAdditionalActivities.chapter_6_table_activity_1.show = function( section ) {
      Show( section );
    };
  
    var currentStep = 0,
      previousMessage,
      svgLines,
      svg_node,
      section_global,
      tables,
      continueBtn,
      datas = [[],[],[],[],[],[],[],[],[],[]],
      messages_node = [];
  
    var Init = function( section ) {
      //section_global = section;
  
       var section_node = section.jq[0],
         message_id = "#message_",
         section_id = "#digfir_section_23",
         cells,
         i;
  
      tables = document.querySelectorAll(section_id + " .activity_table");
      cells = section_node.querySelectorAll( section_id + " [data-activity]" );

      svg_node = section_node.querySelector("svg");
      svg_node.addEventListener("click", drawArrow );

      // Save messages node
      var message;
      for( i = 0; i < TOTAL_MESSAGES; i += 1 ){
        message = section_node.querySelector( message_id + ( i + 1 ) );
        message.style.display = "none";
        messages_node.push( message );
      }
  
      var data_cell,
        data,
        index,
        j;
  
      // matching the "td" and messages in arrays ( messages_node and datas )
      // for example: messages[0] has message from table data(-s) which contain in datas[0].
      for( i = 0; i < cells.length; i += 1 ){
        data_cell = cells[i].getAttribute("data-activity");
  
        data = data_cell.split(",");
  
        for( j = 0; j < data.length; j += 1 ){
          data[j] = parseInt( data[j], 10 );
          index = data[j] - 1;
  
          datas[index].push( cells[i] );
        }
      }

    }; //end init
  
    var tableIndex = 0;
    function showNextTable(){
      tables[tableIndex].style.display = "none";
      
      tableIndex++;
      if( tableIndex > tables.length - 1 ){
        tableIndex = 0;
      }
  
      tables[tableIndex].style.display = "table";
    }
  
    function drawArrow(){
      hideArrows();
      var currentData,
        currentMessage,
        endPos = [],
        section_id = "#digfir_section_23",
        startPos;
  
      if( currentStep === STEPS ){
        currentStep = 0;
        showNextTable();
  
        // brb
        //submit_hidden_arga_question();

        if( isPassed ){
          continueBtn.style.display = 'block';
          section_global.passed = "passed";
        }
        return;
      }
  
      if( currentStep === 4 ){
        showNextTable();
      } else if( currentStep === 7 ) {
        showNextTable();
      }
  
      currentData = datas[currentStep];
      currentMessage = messages_node[currentStep];
  
      currentMessage.style.display = "block";

      previousMessage && ( previousMessage.style.display = "none" );
      previousMessage = currentMessage;

      startPos = makeAbsoluteContext(currentMessage, svg_node, true);

      if( !svgLines ){
        svgLines = document.querySelectorAll(section_id + " .main-arrow");
      }

      for( var i = 0; i < currentData.length; i += 1 ){

        endPos[i] = makeAbsoluteContext(currentData[i], svg_node, false);
        (endPos[i].x < startPos.x) ? endPos[i].x += 10 : endPos[i].x -= 10;

        svgLines[i].setAttribute( "x1", startPos.x );
        svgLines[i].setAttribute( "y1", startPos.y );

        svgLines[i].setAttribute( "x2", endPos[i].x );
        svgLines[i].setAttribute( "y2", endPos[i].y );

        svgLines[i].style.display = "block";
      }

      currentStep += 1;
    }
  
    function hideArrows(){
      if( svgLines ){
        for( var i = 0; i < svgLines.length; i += 1 ){
          svgLines[i].style.display = "none";
        }
      }
    }

    function makeAbsoluteContext(element, svgDocument, isTop) {
      var pt = svgDocument.createSVGPoint(),
          point;
      var width = element.getBoundingClientRect().width / 2;
      var height = element.getBoundingClientRect().height;

      pt.x = width + element.getBoundingClientRect().left;
      pt.y = (isTop ? 0 : height) + element.getBoundingClientRect().top;
      point = pt.matrixTransform(svgDocument.getScreenCTM().inverse());

      return {x: point.x, y: point.y};
    }
  
    var Show = function( section ) {
      /*
      continueBtn = document.getElementById('step_next_button' );
      if( isPassed ){
        continueBtn.style.display = 'block';
        section.passed = "passed";
      } else {
        continueBtn.style.display = 'none';
        section.passed = "no_passed";
      }
      */
    };
  
  })();
