(function(){
  var isPassed = false;

  window.mheAdditionalActivities = window.mheAdditionalActivities || {};
  window.mheAdditionalActivities.chapter_8_graph_activity_2 = {};
  window.mheAdditionalActivities.chapter_8_graph_activity_2.initialize = function( section ) {
      Init( section );
  };
  window.mheAdditionalActivities.chapter_8_graph_activity_2.show = function( section ) {
      Show( section );
  };

  window.mheAdditionalActivities.chapter_8_graph_activity_2.showAnswer = function() {
      showAnswer();
  };

  var board,
  graph,
  bars,
  currentSection,
  continueBtn,
  submitGraphBtn,
  feedbackGraph,
  barLines = [],
  midpoints = [],
  tries = 0,
  SEC_ID = "#digfir_section_26", // brb
  DISABLED = false, // brb
  ANSWERS = [
      660.91,
      -100 ,
      571.84
  ];

var BOARD_OPTIONS = {
      boundingbox: [ 0, 710, 5, 0],
      showCopyright: false,
      showNavigation: false
  },
  AXIS_OPTIONS_Y = {
      straightFirst: false,
      straightLast: true,
      lastArrow: false,
      strokeWidth: 4,
      ticks: {
          minorTicks: 0,
          minTicksDistance: 30,
          drawLabels: true,
          majorHeight: 1000,
          label: {
              offset: [-30, 0],
              highlight: false
          }
      },
      highlight: false
  },
  AXIS_OPTIONS_X = {
      straightFirst: true,
      straightLast: false,
      lastArrow: false,
      strokeWidth: 2,
      ticks: {
          majorHeight: 0,
          tickEndings: [0, -1],
          opacity: 0.2,
          label: {
              visible: false,
              offset: [0, -30],
              highlight: false
          }
      },
      highlight: false
  },
  TICKS_X_OPTIONS = {
      tickEndings: [0, 1],
      strokeColor: '#000',
      strokeWidth: 2,
      minorTicks: 0,
      majorheight: 10,
      labels: ["Multi-tasking", "Sequential"],
      label: {
          offset: [ -26, -8 ]
      },
      drawLabels: true,
      drawZero: true
  },
  AXIS_ARR_Y = [
      [0, 0],
      [0, 710]
  ],
  AXIS_ARR_X = [
      [0, 0],
      [15, 0]
  ];
var
  BAR_OPTIONS = {
      chartStyle: 'bar',
      width: 1.2,
      withLines: true,
      opacity: 2,
      colors: ["#2C9DBA", "white", "#D40013" ]
  },
  POINTS_MALE_OPTIONS = {
      name: "",
      face: "[]",
      color: "",
      label: {
          offset: [9, 0]
      },
    frozen: true,
    highlight: false
  },
  POINTS_FEMALE_OPTIONS = {
      name: "",
      face: "[]",
      color: "",
      label: {
          offset: [9, 0]
      },
    frozen: true,
    highlight: false
  },
  LINE_OPTIONS = {
      straightFirst: false,
      straightLast: false,
      opacity: 0,
      point1: {
          snapSizeY: 1,
          snapSizeX: 0.1
      },
      point2: {
          snapSizeY: 1,
          snapSizeX: 0.1
      },
    frozen: true,
    highlight: false
  },
  POINTS_OPTIONS = {
      name: "",
      showInfobox: false,
      visible: false
  };

var Init = function( section ) {
currentSection = section;
submitGraphBtn = document.querySelector(".submit_graph1");
feedbackGraph = document.querySelector(".feedback_graph1");
};

// brb: This function gets called EVERY TIME the user navigates
// to the page.
var Show = function( section ){
  
  // brb: if we have already disabled this graph then there is
  // nothing that needs to be done;
  /*
  if (DISABLED) {
      return;
  }
  */
  
  section.jq[0].style.display = "block";

  // brb: if we have already completed this graph then set
  // isPassed to true.
  var all_arga_answered = true;

  if (player.ARGA_running) {
      var $curr_sec = $(SEC_ID);
      $curr_sec.find("[data-type='question']").each(function() {
          var $this = $(this);
          var q_index = $this.attr("data-question_index");
      var question = player.activity.questions[q_index];
          
          all_arga_answered = all_arga_answered && (Number(question.queries[0].grade) > -1);
      });
      
      if (all_arga_answered) {
          isPassed = true;
      }
  }
  
  if( !graph ){
    createGraph();

    /*var patternID = 'diagonalHatchPattern';
    var $board = $('#digfir_section_36 #G2Dbox2');
    
    $board.find('defs').append(
      '<pattern id="' + patternID + '" patternUnits="userSpaceOnUse" width="10" height="10">'
      + '<rect width="100" height="100" fill="red"></rect>'
      + '<line x1="0" y1="0" x2="11" y2="11" style="stroke:black; stroke-width:2"></line>'
      + '</pattern>'
    );

    $board.find('[fill="#D40013"]').attr('fill', 'url(#' + patternID + ')');

    board.update(); */
  }

  continueBtn = document.getElementById('step_next_button' );

  // brb : If we have already completed graph page then show
  // the answer.
  if (player.ARGA_running) {
      if (all_arga_answered) {
          showAnswer();
          feedbackGraph.innerHTML = "The graph activity has been completed.";
      }
  }

  /*
  if( isPassed ){
      continueBtn.style.display = 'block';
      section.passed = "passed";
  } else {
      continueBtn.style.display = 'none';
      section.passed = "no_passed";
  }
  */
};

function createGraph() {
var x, fixedTicks = [ 0.8, 2.9 ];

board = G2D.G2DGraph.initBoard( "G2Dbox2_2", BOARD_OPTIONS );

// Generate x and y axis
x = board.create('axis', AXIS_ARR_X, AXIS_OPTIONS_X );
board.create('axis', AXIS_ARR_Y, AXIS_OPTIONS_Y );

// Create bars
if (isPassed) {
bars = board.create("chart", [660.91, -100, 571.84], BAR_OPTIONS );
} else {
bars = board.create("chart", [0, -100, 0], BAR_OPTIONS );
} 

//Create ticks
board.create( "ticks", [x, fixedTicks], TICKS_X_OPTIONS );

//Create legend
//board.create("point", [9.5, 3.5], POINTS_MALE_OPTIONS);
//board.create("point", [9.5, 3.0], POINTS_FEMALE_OPTIONS);

board.unsuspendUpdate();
board.update();
initDraggable();
setMidpoints();
}

function setMidpoints(){
var MIDPOINT_OPTIONS = {
fixed: true,
showInfobox: false,
face: "",
label: {
  offset: [-10, 0]
}
};

var i, bar, midpoint, supportPoint;
for( i = 0; i < bars[0].length; i += 1 ){
bar = bars[0][i];

if (i != 1) {
    supportPoint = board.create( "point", [bar.vertices[1].X(), 110], { visible: false } );

    midpoint = board.create( "midpoint", [ supportPoint, bar.vertices[2] ], MIDPOINT_OPTIONS );
    midpoint.setAttribute( {
        name: function(){
            return '<div class="bar-label">' + this.vertices[1].Y().toFixed(2)+ '</div>';
        }.bind( bar )
    });
    midpoints.push( midpoint );
}
}
$('#digfir_section_26 .bar-label').hide();
}

var helpLine;
function initDraggable( ) {
var vertices, points, p1, p2, topBorderPoints = [], line, crutch;

for( var i = 0; i < bars[0].length; i += 1 ){

vertices = bars[0][i].vertices;

points = [];
points.push( vertices[1] );
points.push( vertices[2] );

p1 = board.create( "point", [vertices[1].X(), vertices[1].Y()], POINTS_OPTIONS );
p2 = board.create( "point", [vertices[2].X(), vertices[2].Y()], POINTS_OPTIONS );

topBorderPoints.push( points );

line = board.create( "line", [p1, p2], LINE_OPTIONS );
line.barPoints = points;

line.on("mouseup", function(){
  helpLine.hideElement();
});

line.on('up',function(i){

  var timer = 500;
  var distance=0.30;

  var correct1 = [660.91, -100 , 571.84];

  if((crutch<correct1[i]+distance)&&(crutch>correct1[i]-distance)){

    barLines[i].point1.moveTo([barLines[i].point1.X(), correct1[i]], timer);
    barLines[i].point2.moveTo([barLines[i].point2.X(), correct1[i]], timer);

    barLines[i].barPoints[0].moveTo([barLines[i].barPoints[0].X(), correct1[i]], timer);
    barLines[i].barPoints[1].moveTo([barLines[i].barPoints[1].X(), correct1[i]], timer);
    barLines[i].user_answer = correct1[i];
  }
  board.update();
}.bind(this, i));

submitGraphBtn.addEventListener("click", checkAnswer );

barLines.push( line );
}
board.update()
}

function showAnswer( ){

  // brb
  submitGraphBtn.style.display = "none";
  
  var correct = [660.91, -100 , 571.84];
  
  for( var i = 0; i < barLines.length; i += 1 ){
      barLines[i].point1.moveTo([ barLines[i].point1.X(), correct[i] ], 500 );
      barLines[i].point2.moveTo([ barLines[i].point2.X(), correct[i] ], 500 );
      
      barLines[i].barPoints[0].moveTo([ barLines[i].barPoints[0].X(), correct[i] ], 500 );
      barLines[i].barPoints[1].moveTo([ barLines[i].barPoints[1].X(), correct[i] ], 500 );
  }

  // brb: disable drag/drop
  for (var i=0; i<barLines.length; i++) {
      var line = barLines[i];
      line.off("drag");
      line.off("mouseup");
      line.off('up');
      line.remove();
  }
  // brb: set this to true so the next time we call Show() we
  // don't do anything
  DISABLED = true;
  
}

function checkAnswer(){
  var user_answer;
  
  for( var i = 0; i < barLines.length; i += 1 ){
      
      user_answer = barLines[i].user_answer;
      if (i == 2) {user_answer = -100;}
      
      isPassed = true;
      
      if( user_answer !== ANSWERS[i] ){
          isPassed = false;
          
          continue;
      }
  }
  
  if( isPassed || ( !isPassed && tries === 2 ) ){
      
      //submit_hidden_arga_question();
      continueBtn.style.display = 'block';
      currentSection.passed = "passed";
      submitGraphBtn.style.display = "none";
      
      showAnswer();
      
      // brb: Give a different message if the user never got the
      // correct answer.
      if (tries === 2) {
          feedbackGraph.innerHTML = "The correct answer is shown above.";
      }
      else {
          feedbackGraph.innerHTML = "Correct!";
      }
      
      isPassed = true;
      return;
  }

  tries += 1;
  
  feedbackGraph.innerHTML = tries + " of 3 attempts. Incorrect. Please try again."
}
  
})();
