(function(){
    var isPassed = false;
  
    window.mheAdditionalActivities = window.mheAdditionalActivities || {};
  
    window.mheAdditionalActivities.chapter_9_graph_activity = {};
    window.mheAdditionalActivities.chapter_9_graph_activity.initialize = function( section ) {
      Init( section );
    };
    window.mheAdditionalActivities.chapter_9_graph_activity.show = function( section ) {
      Show( section );
    };
    window.mheAdditionalActivities.chapter_9_graph_activity.showAnswer = function() {
      showAnswer();
    };
  
    var board,
    graph,
    bars,
    currentSection,
    continueBtn,
    submitGraphBtn,
    feedbackGraph,
    midpoints = [],
    barLines = [],
    tries = 0,
    SEC_ID = "#digfir_section_26", // brb
    DISABLED = false, // brb
    ANSWERS = [
      5.07,
      1.47,
      1.50
    ];

  var BOARD_OPTIONS = {
      boundingbox: [ 0, 7, 4, 0],
      showCopyright: false,
      showNavigation: false
    },
    AXIS_OPTIONS_Y = {
      straightFirst: true,
      straightLast: false,
      lastArrow: false,
      strokeWidth: 4,
      ticks: {
        minorTicks: 1,
        minTicksDistance: 8,
        drawLabels: true,
        majorHeight: 1000,
        label: {
          offset: [-25, 0],
          highlight: false
        }
      },
      highlight: false
    },
    AXIS_OPTIONS_X = {
      straightFirst: true,
      straightLast: true,
      lastArrow: false,
      strokeWidth: 4,
      ticks: {
        majorHeight: 0,
        tickEndings: [0, -1],
        opacity: 0,
        label: {
          visible: false,
          offset: [0, -15],
          highlight: false
        }
      },
      highlight: false
    },
    AXIS_ARR_Y = [
      [0, 0],
      [0, 7]
    ],
    AXIS_ARR_X = [
      [0, 0],
      [1, 0]
    ];

  var
    BAR_OPTIONS = {
      chartStyle: 'bar',
      width: 0.6,
      opacity: 1,
      withLines: true,
      colors: ["#2C9DBA", "#D40013", "#2C9DBA"]
    },
    TICKS_X_OPTIONS = {
      tickEndings: [0, 1],
      strokeColor: '#000',
      strokeWidth: 2,
      minorTicks: 0,
      majorheight: 15,
      labels: ["Thin dolls", "Realistic dolls", "No dolls"],
      label: {
        offset: [ -37, -10 ]
      },
      drawLabels: true,
      drawZero: true
    },
    LINE_OPTIONS = {
      straightFirst: false,
      straightLast: false,
      opacity: 0,
      point1: {
        snapSizeY: 1,
        snapSizeX: 0.01
      },
      point2: {
        snapSizeY: 1,
        snapSizeX: 0.01
      },
      frozen: true,
      highlight: false
    },
    POINTS_OPTIONS = {
      name: "",
      showInfobox: false,
      visible: false
    };

  var Init = function( section ) {
    currentSection = section;
    submitGraphBtn = document.querySelector(".submit_graph");
    feedbackGraph = document.querySelector(".feedback_graph");

    section.points_possible = 1;
    section.points_earned = 0;
    section.section_completed = false;
  };

  // brb: This function gets called EVERY TIME the user navigates
  // to the page.
  var Show = function( section ){

    // brb: if we have already disabled this graph then there is
    // nothing that needs to be done;
    /*
    if (DISABLED) {
      return;
    }
    */

    section.jq[0].style.display = "block";

    // brb: if we have already completed this graph then set
    // isPassed to true.
    var all_arga_answered = true;

    if (player.ARGA_running) {
      var $curr_sec = $(SEC_ID);
      $curr_sec.find("[data-type='question']").each(function() {
        var $this = $(this);
        var q_index = $this.attr("data-question_index");
        var question = player.activity.questions[q_index];

        all_arga_answered = all_arga_answered && (Number(question.queries[0].grade) > -1);
      });

      if (all_arga_answered) {
        isPassed = true;
      }
    }

    if( !graph ){
      createGraph();
    }

    continueBtn = document.getElementById('step_next_button' );

    // brb : If we have already completed graph page then show
    // the answer.
    if (player.ARGA_running) {
      if (all_arga_answered) {
        showAnswer();
        feedbackGraph.innerHTML = "The graph activity has been completed.";
      }
    }

    /*
    if( isPassed ){
      continueBtn.style.display = 'block';
      section.passed = "passed";
    } else {
      continueBtn.style.display = 'none';
      section.passed = "no_passed";
    }
    */
  };

  function createGraph() {
    var x, fixedTicks = [1,2,3.1];

    board = G2D.G2DGraph.initBoard( "G2Dbox2", BOARD_OPTIONS );

    // Generate x and y axis
    x = board.create('axis', AXIS_ARR_X, AXIS_OPTIONS_X );
    board.create('axis', AXIS_ARR_Y, AXIS_OPTIONS_Y );
    board.create( "ticks", [x, fixedTicks], TICKS_X_OPTIONS );

    // Create bars
    if (isPassed) {
      bars = board.create("chart", [5.07, 1.47, 1.50], BAR_OPTIONS );
    } else {
      bars = board.create("chart", [0, 0, 0], BAR_OPTIONS );
    }

    // update
    board.unsuspendUpdate();
    board.update();
    initDraggable();
    setMidpoints();
  }

  function setMidpoints(){
    var MIDPOINT_OPTIONS = {
      fixed: true,
      showInfobox: false,
      face: "",
      label: {
        offset: [-15, 0]
      }
    };

    var i, bar, midpoint, supportPoint;
    for( i = 0; i < bars[0].length; i += 1 ){
      bar = bars[0][i];

      supportPoint = board.create( "point", [bar.vertices[1].X(), 0.6], { visible: false } );

      midpoint = board.create( "midpoint", [ supportPoint, bar.vertices[2] ], MIDPOINT_OPTIONS );
      midpoint.setAttribute( {
        name: function(){
          return '<div class="bar-label">' + (Math.round( this.vertices[1].Y() * 100 ) / 100).toPrecision(3) + '</div>';
        }.bind( bar )
      });
      midpoints.push( midpoint );
    }
    $('.bar-label').hide();
  }

  var helpLine;
  function initDraggable( ) {
    var vertices, points, p1, p2, topBorderPoints = [], line, user_answer;

    for( var i = 0; i < bars[0].length; i++ ){
      vertices = bars[0][i].vertices;

      points = [];
      points.push( vertices[1] );
      points.push( vertices[2] );

      p1 = board.create( "point", [vertices[1].X(), vertices[1].Y()], POINTS_OPTIONS );
      p2 = board.create( "point", [vertices[2].X(), vertices[2].Y()], POINTS_OPTIONS );

      topBorderPoints.push( points );

      line = board.create( "line", [p1, p2], LINE_OPTIONS );
      line.barPoints = points;

      line.on("mouseup", function(){
        helpLine.hideElement();
      });

      line.on('up',function(i){

        var timer = 500;
        var distance = 0.05;

        var correct1 = [5.07, 1.47, 1.50];

        if(( user_answer < correct1[i] + distance ) && ( user_answer > correct1[i] - distance )){

          barLines[i].point1.moveTo([barLines[i].point1.X(), correct1[i]], timer);
          barLines[i].point2.moveTo([barLines[i].point2.X(), correct1[i]], timer);

          barLines[i].barPoints[0].moveTo([barLines[i].barPoints[0].X(), correct1[i]], timer);
          barLines[i].barPoints[1].moveTo([barLines[i].barPoints[1].X(), correct1[i]], timer);
          barLines[i].user_answer = correct1[i];
        }
        board.update();
      }.bind( this, i ));

      submitGraphBtn.addEventListener("click", checkAnswer );

      barLines.push( line );
    }
    board.update()
  }

  function showAnswer( ){

    // brb
    submitGraphBtn.style.display = "none";

    var correct = [5.07, 1.47, 1.50];

    for( var i = 0; i < barLines.length; i++ ){
      barLines[i].point1.moveTo([ barLines[i].point1.X(), correct[i] ], 500 );
      barLines[i].point2.moveTo([ barLines[i].point2.X(), correct[i] ], 500 );

      barLines[i].barPoints[0].moveTo([ barLines[i].barPoints[0].X(), correct[i] ], 500 );
      barLines[i].barPoints[1].moveTo([ barLines[i].barPoints[1].X(), correct[i] ], 500 );
    }

    // brb: disable drag/drop
    for (var i=0; i<barLines.length; i++) {
      var line = barLines[i];
      line.off("drag");
      line.off("mouseup");
      line.off('up');
      line.remove();
    }
    // brb: set this to true so the next time we call Show() we
    // don't do anything
    DISABLED = true;
  }

  function finishSlide(){
    currentSection.points_earned = currentSection.points_possible;
    currentSection.section_completed = true;

    player.activity.grade_activity();
    player.update_section_status();
    player.update_navigation();
  }

  function checkAnswer(){
    var user_answer;

    for( var i = 0; i < barLines.length; i += 1 ){
      user_answer = barLines[i].user_answer;
      //user_answer = Math.round( user_answer * 20) / 2;

      safe_log("user_answer = " + user_answer);

      isPassed = true;
      if( user_answer !== ANSWERS[i] ){
        isPassed = false;

        continue;
      }
    }

    if( isPassed || ( !isPassed && tries === 2 ) ){

      /*
      if (isPassed) {
        submit_hidden_arga_question();
      }
      else {
        submit_hidden_arga_question("incomplete");
      }
      */

      continueBtn.style.display = 'block';
      currentSection.passed = "passed";
      submitGraphBtn.style.display = "none";

      showAnswer();

      // brb: Give a different message if the user never got the
      // correct answer.
      if (tries === 2) {
        feedbackGraph.innerHTML = "The correct answer is shown above.";
      }
      else {
        feedbackGraph.innerHTML = "Correct!";
      }

      finishSlide();
      //feedbackGraph.innerHTML = "Correct!";

      isPassed = true;
      return;
    }

    tries += 1;
    feedbackGraph.innerHTML = tries + " of 3 attempts. Incorrect. Please try again."
  }
  })();