function clean_query_text (query_text) {
  query_text = query_text.replace(/<span [^>]+>/g, '');
  query_text = query_text.replace(/<\/span>/g, '');
  query_text = query_text.replace(/<em>/g, '');
  query_text = query_text.replace(/<\/em>/g, '');
  query_text = query_text.replace(/<strong>/g, '');
  query_text = query_text.replace(/<\/strong>/g, '');
  query_text = query_text.replace(/<br\/>/g, '');
  query_text = query_text.replace(/<br>/g, '');
  query_text = query_text.replace(/’/g, '\'');
  query_text = query_text.replace(/“/g, '"');
  query_text = query_text.replace(/”/g, '"');
  query_text = query_text.replace(/—/g, '--');
  return query_text;
}

function submit_hidden_arga_question(answer) {
  // if we aren't in ARGA mode then we don't need to do anything
  /* We can't do this or we won't be able to move past these
     activities in non-ARGA mode */

  if (!player.ARGA_running) {
      //safe_log("submit_hidden_arga_question: not in ARGA mode");
      return;
  }

  var curr_sec = player.section_currently_showing;

  //safe_log("submit_hidden_arga_question: curr_sec = " + curr_sec);

  var $sec = $('#digfir_section_' + curr_sec);
  var $question = $sec.find('[data-type=\'question\']');

  if (answer === undefined) {
      answer = 'completed';
  }

  //safe_log("submit_hidden_arga_question: answer = " + answer);

  // there should only be 1 hidden question on the page and
  // no other arga questions
  if ($question.length !== 1) {
      //safe_log("submit_hidden_arga_question: ERROR: must be exactly one ARGA question on page (there are " + $question.length + ")");
      return;
  }

  // make sure this is a hidden question
  var $submit_button = $question.find('input[type=\'button\']');
  if ($submit_button.length == 0) {
      //safe_log("submit_hidden_arga_question: ERROR: no hidden arga question on page");
      return;
  }

  var question_index = $question.attr('data-question_index');

  // only submit if the question hasn't been submitted already
  if (!player.activity.questions[question_index].is_complete()) {
      var query = player.activity.questions[question_index].queries[0];
      //safe_log("submitting hidden ARGA question");
      query.setUserAnswer(answer);
      $submit_button.click();

      // if LASX == current section then increment LASX by 1
      if (!player.ARGA_running) {
          var las = NaN; // Get_ARGA_Data("LASX");
          var curr_sec = this.section_currently_showing;

          if (curr_sec !== null && las == curr_sec) {
              //safe_log("incrementing LASX to " + (curr_sec + 1));
              Set_ARGA_Data('LASX', curr_sec + 1);
              this.activity.ARGA_submit_data(false);
              this.last_available_section = curr_sec + 1;
          }
          else {
              // safe_log("LASX does not need to be incremented.");
          }
      }
  }
  else {
      // safe_log("Not submitting. Question is complete.");
  }
}
